﻿Public Class frm_stopwatch
   Dim stime, etime As DateTime

   Private Sub btn_start_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_start.Click
      stime = Now
      etime = DateTime.MinValue
      tmr.Start()
      log("Started at " & stime.ToString("hh:mm:ss:") & stime.Millisecond.ToString)
      SetElapsed(lbl_abs, TimeSpan.Zero)
   End Sub

   Private Sub btn_stop_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_stop.Click
      etime = Now
      tmr.Stop()
      Dim dlt As TimeSpan = etime.Subtract(stime)
      log("Stopped at " & etime.ToString("hh:mm:ss:") & etime.Millisecond.ToString & _
          " Delta " & dlt.Hours.ToString("00") & ":" & dlt.Minutes.ToString("00") & ":" & _
          dlt.Seconds.ToString("00") & ":" & dlt.Milliseconds.ToString("000"))
      SetElapsed(lbl_abs, etime.Subtract(stime))
   End Sub

   Private Sub btn_reset_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btn_reset.Click
      SetElapsed(lbl_elapsed, TimeSpan.Zero)
      SetElapsed(lbl_abs, TimeSpan.Zero)
      stime = Now
      etime = DateTime.MinValue
      lst_log.Items.Clear()
   End Sub

   Private Sub tmr_Tick(ByVal sender As Object, ByVal e As EventArgs) Handles tmr.Tick
      SetElapsed(lbl_elapsed, Now.Subtract(stime))
   End Sub

   Private Sub SetElapsed(ByVal lbl As Label, ByVal dtime As TimeSpan)
      lbl.Text = String.Format("{0:00}:{1:00}:{2:00}:{3:000}", dtime.Hours, dtime.Minutes, dtime.Seconds, dtime.Milliseconds)
   End Sub

   Private Sub log(ByVal msg As String)
      lst_log.Items.Add(msg)
      lst_log.TopIndex = lst_log.Items.Count - 1
   End Sub

End Class
